
void CheckSegment(u32 *MCUCnt)
{
  if(CheckSegment_EndFlag==True) return;
  
  if(rbsCheckSegment()==True){
    if(rbsEOIFlag==True){
      _consolePrintf("MCU(%d):EOI End of image segment\n",*MCUCnt);
      CheckSegment_EndFlag=True;
      return;
    }
    if(rbsRSTFlag==True){
      if(rbsRST_Skip1MCUFlag==True){
//        _consolePrintf("MCUCnt++\n");
        *MCUCnt=*MCUCnt+1;
      }
      u32 ScanCnt;
      for(ScanCnt=0;ScanCnt<ScanCount;ScanCnt++){
        ScanInfo[ScanCnt].DCDiff=0;
      }
      *MCUCnt=((*MCUCnt-1) / FrameInfo.MCUWidthCount)*FrameInfo.MCUWidthCount+FrameInfo.MCUWidthCount;
//      _consolePrintf("MCU(%d):RSTx\n",*MCUCnt);
    }
    if(rbsErrorFlag==True){
      _consolePrintf("MCU(%d):DetectErrorMarker\n",*MCUCnt);
      while(1);
    }
  }
}


void LoadIntBlock(u32 ScanCnt,TIntBlock *IntBlock)
{
  TScanInfo *_ScanInfo=&ScanInfo[ScanCnt];
  THuffmanTree *_HuffmanTreeAC=_ScanInfo->HuffmanTreeAC;
  u8 *QuantizeData=&_ScanInfo->QuantizeTable->data[0];
  
  u32 dctcnt;
  u32 bitlen;
  
  bitlen=rbsDecodeHuffman(_ScanInfo->HuffmanTreeDC);
  if(bitlen!=0){
    _ScanInfo->DCDiff+=rbsGetVL(bitlen);
  }
  IntBlock[0]=_ScanInfo->DCDiff*QuantizeData[0];
  
  for(dctcnt=1;dctcnt<64;dctcnt++){
    IntBlock[dctcnt]=0;
  }
  
  dctcnt=1;
  while(dctcnt<64){
    bitlen=rbsDecodeHuffman(_HuffmanTreeAC);
    if(bitlen==0x00){
      dctcnt=64;
      }else{
      dctcnt+=bitlen >> 4; // zerorun
{//      if(dctcnt<64){
        bitlen=bitlen & 0x0f;
        if(bitlen!=0){
          IntBlock[zigzag[dctcnt]]=rbsGetVL(bitlen)*QuantizeData[dctcnt];
        }
      }
      dctcnt++;
    }
  }
  
  Fast_IDCT(&IntBlock[0]);
}

#define DecodeImageOne_CalcYUV(blk,cmp) { \
  cmp=(blk+(0x10<<3)) >> 3; \
  if((u32)cmp>0x1f) cmp=(cmp<0) ? 0x00 : 0x1f; \
}

#define fixrate (0x100)

s32 gr=0,gg=0,gb=0;

u16 YUV2RGB(s32 _Y,s32 _Cb,s32 _Cr)
{
  s32 r,g,b;
  
  _Y+=128;
  
#define Gravity(c,cg) { \
  c+=cg; \
  cg=c&7; \
  c=c>>3; \
  if((c&(~0x1f))!=0) c=(c<0) ? 0x00 : 0x1f; \
}
  
  r = ( ((s32)(1*fixrate)) * _Y )                                     + ( ((s32)(1.4020*fixrate)) * _Cr );
  r/=fixrate;
  Gravity(r,gr);
  
  g = ( ((s32)(1*fixrate)) * _Y ) - ( ((s32)(0.3441*fixrate)) * _Cb ) - ( ((s32)(0.7139*fixrate)) * _Cr );
  g/=fixrate;
  Gravity(g,gg);
  
  b = ( ((s32)(1*fixrate)) * _Y ) + ( ((s32)(1.7718*fixrate)) * _Cb ) - ( ((s32)(0.0012*fixrate)) * _Cr );
  b/=fixrate;
  Gravity(b,gb);
  
  return(RGB15(r,g,b) | BIT(15));

#undef Gravity
}

#undef fixrate

void IntBlockDrawUnknown(u16 *DrawPtr)
{
}

void IntBlockDraw111(u16 *DrawPtr)
{
  LoadIntBlock(0,&Y0Block[0]);
  LoadIntBlock(1,&CbBlock[0]);
  LoadIntBlock(2,&CrBlock[0]);
  
  if(DrawPtr==NULL) return;
  
  u16 *VRAMPtr=DrawPtr;
  
  TIntBlock *YBlk=&Y0Block[0];
  TIntBlock *CbBlk=&CbBlock[0];
  TIntBlock *CrBlk=&CrBlock[0];
  
  u32 x,y;
  u32 ofs=0;
  
  for(y=8;y>0;y--){
    for(x=8;x>0;x--){
      *VRAMPtr=YUV2RGB(YBlk[ofs],CbBlk[ofs],CrBlk[ofs]);
      ofs++;
      VRAMPtr++;
    }
    VRAMPtr+=-8+(JpegTempBMWidth*1);
  }
  
}

void IntBlockDraw411(u16 *DrawPtr)
{
  LoadIntBlock(0,&Y0Block[0]);
  LoadIntBlock(0,&Y1Block[0]);
  LoadIntBlock(0,&Y2Block[0]);
  LoadIntBlock(0,&Y3Block[0]);
  LoadIntBlock(1,&CbBlock[0]);
  LoadIntBlock(2,&CrBlock[0]);
  
  if(DrawPtr==NULL) return;
  
  u16 *VRAMPtr=DrawPtr;
  
  TIntBlock *YBlk;
  TIntBlock *CbBlk;
  TIntBlock *CrBlk;
  
  u32 ofsy,ofsc;
  
  CbBlk=&CbBlock[0];
  CrBlk=&CrBlock[0];
  
#define trans411_insideY(adofs,adptr) { \
  _Y=YBlk[ofsy]; \
  ofsy+=adofs; \
  *VRAMPtr=YUV2RGB(_Y,_Cb,_Cr); \
  VRAMPtr+=adptr; \
}

#define trans411() { \
  u32 x,y; \
  s32 _Y,_Cb,_Cr; \
   \
  for(y=4;y>0;y--){ \
    for(x=4;x>0;x--){ \
      _Cb=CbBlk[ofsc]; \
      _Cr=CrBlk[ofsc]; \
      ofsc++; \
       \
      trans411_insideY(1,1); \
      trans411_insideY(-1+8,-1+JpegTempBMWidth); \
      trans411_insideY(1,1); \
      trans411_insideY(1-8,1-JpegTempBMWidth); \
    } \
    ofsc+=-4+(8*1); \
    ofsy+=-8+(8*2); \
    VRAMPtr+=-8+(JpegTempBMWidth*2); \
  } \
}

  YBlk=&Y0Block[0];
  VRAMPtr=DrawPtr;
  VRAMPtr+=0+(0*JpegTempBMWidth);
  ofsy=0;
  ofsc=0+(0*8);
  
  trans411();
  
  YBlk=&Y1Block[0];
  VRAMPtr=DrawPtr;
  VRAMPtr+=8+(0*JpegTempBMWidth);
  ofsy=0;
  ofsc=4+(0*8);
  
  trans411();
  
  YBlk=&Y2Block[0];
  VRAMPtr=DrawPtr;
  VRAMPtr+=0+(8*JpegTempBMWidth);
  ofsy=0;
  ofsc=0+(4*8);
  
  trans411();
  
  YBlk=&Y3Block[0];
  VRAMPtr=DrawPtr;
  VRAMPtr+=8+(8*JpegTempBMWidth);
  ofsy=0;
  ofsc=4+(4*8);
  
  trans411();
  
#undef trans411_insideY
#undef trans411
}

void IntBlockDraw100(u16 *DrawPtr)
{
  LoadIntBlock(0,&Y0Block[0]);
  
  if(DrawPtr==NULL) return;
  
  u16 *VRAMPtr=DrawPtr;
  
  TIntBlock *YBlk=&Y0Block[0];
  
  u32 x,y;
  u32 ofs=0;
  
  for(y=8;y>0;y--){
    for(x=8;x>0;x--){
      *VRAMPtr=YUV2RGB(YBlk[ofs],0,0);
      ofs++;
      VRAMPtr++;
    }
    VRAMPtr+=-8+(JpegTempBMWidth*1);
  }
  
}

void DecodeImageOne(u32 *_MCUCount,u16 *DrawPtr)
{
  if(CheckSegment_EndFlag==True) return;
  
  u32 MCUCount=*_MCUCount;
  
/* 킩Ȃc
  if(DelayRestartInterval!=0){
    u32 Limit;
    Limit=(MCUCount/DelayRestartInterval);
    Limit=(Limit*DelayRestartInterval);
    while(MCUCount<Limit){
      IntBlockDraw(DrawPtr);
      MCUCount++;
      CheckSegment(&MCUCount);
    }
  }
*/
  
//  IntBlockDraw(DrawPtr);
  IntBlockDraw411(DrawPtr);
  
  MCUCount++;
  CheckSegment(&MCUCount);
  
  *_MCUCount=MCUCount;
}

void DrawImageOneLine(u32 BaseY,u32 LCBMNum)
{
  u32 x;
  u16 *DrawPtr;
  u32 MCUCnt;
  
  u32 MCUWidthSize=FrameInfo.MCUWidthSize;
  u32 MCUHeightSize=FrameInfo.MCUHeightSize;
  u32 MCUWidthCount=FrameInfo.MCUWidthCount;
  
  MCUCnt=BaseY*MCUWidthCount;
  
  {
    u32 MCUCacheIndex=BaseY;
    if(MCUCacheCount<=MCUCacheIndex) MCUCacheIndex=MCUCacheCount-1;
    
    TMCUCache *_MCUCache=&MCUCache[MCUCacheIndex];
    rbsSetCurPos(_MCUCache->PosBit);
    ScanInfo[0].DCDiff=_MCUCache->DCDiff[0];
    ScanInfo[1].DCDiff=_MCUCache->DCDiff[1];
    ScanInfo[2].DCDiff=_MCUCache->DCDiff[2];
  }
  CheckSegment_EndFlag=False;
  
  if(LCBMNum!=LCBM_False){
    DrawPtr=JpegTempBM;
    for(x=0;x<MCUWidthCount;x++){
      DecodeImageOne(&MCUCnt,DrawPtr);
      DrawPtr+=MCUWidthSize;
    }
    }else{
    for(x=0;x<MCUWidthCount;x++){
      DecodeImageOne(&MCUCnt,NULL);
    }
  }
  
  if(MCUHeightSize==8){
    if(LCBMNum!=LCBM_False){
      DrawPtr=JpegTempBM;
      DrawPtr+=JpegTempBMWidth*MCUHeightSize;
      for(x=0;x<MCUWidthCount;x++){
        DecodeImageOne(&MCUCnt,DrawPtr);
        if(DrawPtr!=NULL) DrawPtr+=MCUWidthSize;
      }
      }else{
      for(x=0;x<MCUWidthCount;x++){
        DecodeImageOne(&MCUCnt,NULL);
      }
    }
  }
  
  {
    u32 MCUCacheIndex=BaseY+1;
    if(MCUCacheIndex<MCUCacheCount){
      TMCUCache *_MCUCache=&MCUCache[MCUCacheIndex];
      rbsGetCurPos(&_MCUCache->PosBit);
      _MCUCache->DCDiff[0]=ScanInfo[0].DCDiff;
      _MCUCache->DCDiff[1]=ScanInfo[1].DCDiff;
      _MCUCache->DCDiff[2]=ScanInfo[2].DCDiff;
    }
  }
  
  if(LCBMNum==LCBM_False) return;
  
  u16 *srcptr,*dstptr;
  
  srcptr=JpegTempBM;
  dstptr=LCBM[LCBMNum].BM;
  
  for(u32 y=0;y<LCBMHeight;y++){
    MemCopy16DMA3(srcptr,dstptr,LCBMWidth*2);
    srcptr+=JpegTempBMWidth;
    dstptr+=LCBMWidth;
  }
  
}
