
b8 AnalizeJpegMarker(void)
{
  b8 StartSOSFlag;
  u8 Marker0,Marker1;
  
  StartSOSFlag=False;
  
  YUVMode=YUVMode_Unknown;
  DelayRestartInterval=0;
  
  while(StartSOSFlag==False){
    Marker0=rfs8bit();
    Marker1=rfs8bit();
    if(Marker0!=0xff){
      _consolePrintf("Detect NoMark.0x%x 0x%x\n",Marker0,Marker1);
      return(False);
      ShowLogHalt();
      }else{
      switch(Marker1){
        case 0xd8:
          _consolePrintf("Start of image segment\n");
          break;
        case 0xe0:
//          _consolePrintf("APP0 Application marker\n");
          Marker_APP0();
          break;
        case 0xdb:
//          _consolePrintf("DQT Define quantization table segment\n");
          Marker_DQT();
          break;
        case 0xc0:
//          _consolePrintf("SOF0 Start of Frame / Baseline DCT, Huffman\n");
          Marker_SOF0();
          break;
        case 0xc4:
//          _consolePrintf("DHT Define Huffman Table\n");
          Marker_DHT();
          break;
        case 0xdd:
          _consolePrintf("DRI Define Restart Interval\n");
          Marker_DRI();
          break;
        case 0xda:
//          _consolePrintf("SOS Start of scan segment\n");
          Marker_SOS();
          StartSOSFlag=True;
          break;
        default:
          if((0xe1<=Marker1) && (Marker1<=0xef)){
//            _consolePrintf("APPx Extend Application marker\n");
            Marker_APPx();
            }else{
            if(Marker1==0xc2){
              _consolePrintf("Error:SOF NotSupport Start of Frame Type(%x)\n",Marker1);
              _consolePrintf("Progressive DCT (Huffman)(0x%x)\n",Marker1);
              return(False);
            }
            if(((0xc0<=Marker1) && (Marker1<=0xc3)) || ((0xc5<=Marker1) && (Marker1<=0xc7)) || ((0xc9<=Marker1) && (Marker1<=0xcb)) || ((0xcd<=Marker1) && (Marker1<=0xcf))){
              _consolePrintf("Error:SOF NotSupport Start of Frame Type(%x)\n",Marker1);
              _consolePrintf("Detect NotSupport SOF(0x%x)\n",Marker1);
              return(False);
            }
            if((0xf0<=Marker1) && (Marker1<=0xfd)){
              _consolePrintf("Detect JpegReserve Type(%x)\n",Marker1);
              return(False);
            }
            Marker_Unknown();
          }
          break;
      }
    }
  }
  
  BitStreamStartPosition=rfsGetPosition();
  
  return(True);
}

u32 Marker__GetSize(void)
{
  return(rfs16bit()-2);
}

u32 Marker__GetNextPosition(void)
{
  u32 size=Marker__GetSize();
  
  return(rfsGetPosition()+size);
}

void Marker_Unknown(void)
{
  u32 nextpos=Marker__GetNextPosition();
  
  rfsSetPosition(nextpos);
}

void Marker_APP0(void)
{
  u32 nextpos=Marker__GetNextPosition();
  
  rfsSetPosition(nextpos);
}

void Marker_APPx(void)
{
  u32 nextpos=Marker__GetNextPosition();
  
  rfsSetPosition(nextpos);
}

void Marker_DQT(void)
{
  u32 size=Marker__GetSize();
  u32 nextpos;
  
  TQuantizeTable *_QuantizeTable;
  u32 Count,cnt,qcnt;
  u8 tag;
  
  nextpos=rfsGetPosition()+size;
  
  Count=size/65;
  
  for(cnt=0;cnt<Count;cnt++){
    tag=rfs8bit();
    _QuantizeTable=&pQuantizeTable[tag&0x0f];
    _QuantizeTable->Precision=tag >> 4;
    for(qcnt=0;qcnt<64;qcnt++){
      _QuantizeTable->data[qcnt]=(s8)(rfs8bit());
    }
  }
  
  rfsSetPosition(nextpos);
}

void Marker_SOF0(void)
{
  u32 nextpos=Marker__GetNextPosition();
  
  TFrameInfo *_FrameInfo;
  TSampleInfo *_SampleInfo;
  
  u32 cnt;
  u8 tmp;
  
  _FrameInfo=&FrameInfo;
  
  _FrameInfo->DepthPerSample=rfs8bit();
  _FrameInfo->Height=rfs16bit();
  _FrameInfo->Width=rfs16bit();
  SampleCount=rfs8bit();
  
  _FrameInfo->SampleMaxHFact=0;
  _FrameInfo->SampleMaxVFact=0;
  
  SampleInfo[0].HFact=0;
  SampleInfo[0].VFact=0;
  SampleInfo[1].HFact=0;
  SampleInfo[1].VFact=0;
  SampleInfo[2].HFact=0;
  SampleInfo[2].VFact=0;
  
  for(cnt=0;cnt<SampleCount;cnt++){
    u32 ID=rfs8bit()-1;
    if(cnt!=ID){
      _consolePrintf("SOF0:ID Error.\n");
      ShowLogHalt();
    }
    
    _SampleInfo=&SampleInfo[ID];
    
    tmp=rfs8bit();
    _SampleInfo->HFact=tmp >> 4;
    _SampleInfo->VFact=tmp & 0x0f;
    _SampleInfo->QuantizeTableIndex=rfs8bit();
    if(_FrameInfo->SampleMaxHFact<_SampleInfo->HFact) _FrameInfo->SampleMaxHFact=_SampleInfo->HFact;
    if(_FrameInfo->SampleMaxVFact<_SampleInfo->VFact) _FrameInfo->SampleMaxVFact=_SampleInfo->VFact;
    
//    _consolePrintf("debug:SampleInfo[%d]\n",cnt);
//    _consolePrintf("HFact=%d VFact=%d\n",_SampleInfo->HFact,_SampleInfo->VFact);
//    _consolePrintf("QuantizeTableIndex=%d\n",_SampleInfo->QuantizeTableIndex);
  }
  
  if(((SampleInfo[0].HFact==1)&&(SampleInfo[0].VFact==1))&&
     ((SampleInfo[1].HFact==1)&&(SampleInfo[1].VFact==1))&&
     ((SampleInfo[2].HFact==1)&&(SampleInfo[2].VFact==1))){
    _consolePrintf("YUVModeSwitch to YUV111\n");
    YUVMode=YUVMode_111;
  }
  
  if(((SampleInfo[0].HFact==2)&&(SampleInfo[0].VFact==2))&&
     ((SampleInfo[1].HFact==1)&&(SampleInfo[1].VFact==1))&&
     ((SampleInfo[2].HFact==1)&&(SampleInfo[2].VFact==1))){
    _consolePrintf("YUVModeSwitch to YUV411\n");
    YUVMode=YUVMode_411;
  }
  
  if(((SampleInfo[0].HFact==1)&&(SampleInfo[0].VFact==1))&&
     ((SampleInfo[1].HFact==0)&&(SampleInfo[1].VFact==0))&&
     ((SampleInfo[2].HFact==0)&&(SampleInfo[2].VFact==0))){
    _consolePrintf("YUVModeSwitch to YUV100\n");
    YUVMode=YUVMode_100;
  }
  
  _FrameInfo->MCUWidthSize=_FrameInfo->SampleMaxHFact*8;
  _FrameInfo->MCUHeightSize=_FrameInfo->SampleMaxVFact*8;
  
  _FrameInfo->MCUWidthCount=(_FrameInfo->Width+_FrameInfo->MCUWidthSize-1) / _FrameInfo->MCUWidthSize;
  _FrameInfo->MCUHeightCount=(_FrameInfo->Height+_FrameInfo->MCUHeightSize-1) / _FrameInfo->MCUHeightSize;
  _FrameInfo->MCUCount=_FrameInfo->MCUWidthCount*_FrameInfo->MCUHeightCount;
  
  rfsSetPosition(nextpos);
}

void Marker_DHT_CreateHuffmanTree(u32 *hufbit,u32 code,u32 bits)
{
  if(1<bits) Marker_DHT_CreateHuffmanTree(hufbit,code >> 1,bits-1);
  *hufbit=(*hufbit<<1)+(code&0x01);
}

void Marker_DHT(void)
{
  u32 nextpos=Marker__GetNextPosition();
  
  THuffmanTree *_HuffmanTree;
  
  u8 tmp;
  u32 cls,id;
  u32 len[16];
  u32 lcnt,bcnt;
  u32 hufcode,hufbit;
  
  while(rfsGetPosition()<nextpos){
    tmp=rfs8bit();
    cls=tmp >> 4;
    id=tmp & 0x0f;
    for(lcnt=0;lcnt<16;lcnt++){
      len[lcnt]=rfs8bit();
    }
    
    _HuffmanTree=&pHuffmanTree[(cls*2)+id];
    
    _HuffmanTree->size=0;
    hufcode=0;
    for(lcnt=0;lcnt<16;lcnt++){
      for(bcnt=0;bcnt<len[lcnt];bcnt++){
        _HuffmanTree->code[_HuffmanTree->size]=rfs8bit();
        _HuffmanTree->bitcount[_HuffmanTree->size]=lcnt+1;
        hufbit=0;
        Marker_DHT_CreateHuffmanTree(&hufbit,hufcode,_HuffmanTree->bitcount[_HuffmanTree->size]);
        _HuffmanTree->bitimage[_HuffmanTree->size]=hufbit;
        hufcode++;
        _HuffmanTree->size++;
      }
      hufcode=hufcode << 1;
    }
    
  }
  
  rfsSetPosition(nextpos);
}

void Marker_DRI(void)
{
  u32 nextpos=Marker__GetNextPosition();
  
  DelayRestartInterval=rfs16bit();
  
  rfsSetPosition(nextpos);
}

void Marker_SOS(void)
{
  u32 nextpos=Marker__GetNextPosition();
  
  u32 cnt;
  
  ScanCount=rfs8bit();
  
  for(cnt=0;cnt<ScanCount;cnt++){
    u32 ID=rfs8bit()-1;
    if(cnt!=ID){
      _consolePrintf("SOS:ID Error.\n");
      ShowLogHalt();
    }
    
    TScanInfo *_ScanInfo=&ScanInfo[ID];
    b8 tmp;
    
    tmp=rfs8bit();
    _ScanInfo->HuffmanTableDC=tmp >> 4;
    _ScanInfo->HuffmanTableAC=tmp & 0x0f;
    _ScanInfo->HuffmanTreeDC=&pHuffmanTree[(0*2)+_ScanInfo->HuffmanTableDC];
    _ScanInfo->HuffmanTreeAC=&pHuffmanTree[(1*2)+_ScanInfo->HuffmanTableAC];
    _ScanInfo->SampleInfo=&SampleInfo[cnt];
    _ScanInfo->QuantizeTable=&pQuantizeTable[_ScanInfo->SampleInfo->QuantizeTableIndex];
    _ScanInfo->DCDiff=0;
    
//    _consolePrintf("debug:ScanInfo[%d]\n",cnt);
//    _consolePrintf("HuffmanTableDC=%d at 0x%x\n",_ScanInfo->HuffmanTableDC,(u32)_ScanInfo->HuffmanTreeDC);
//    _consolePrintf("HuffmanTableAC=%d at 0x%x\n",_ScanInfo->HuffmanTableAC,(u32)_ScanInfo->HuffmanTreeAC);
  }
  
  rfsSetPosition(nextpos);
}
