
#include <stdio.h>

#include <NDS.h>

#include "_const.h"

#include "plugin.h"
#include "plugin_def.h"

#include "inifile.h"

#include "mdxplay/mdx.h"
#include "mdxplay/masterdef.h"

// CallBack from plugin_dll.cpp

void cbLoadLibrary(void)
{
}

void cbFreeLibrary(void)
{
}

void cbQueryInterfaceLibrary(void)
{
}

// -----------------

static u8 *DeflateBuf=NULL;
static u32 DeflateSize;

// --------------------------------------------------------------------

int MASTER_PCM_RATE;
int MASTER_PCM_SAMPLES_PER_FRAME;

// ------------------------------------------------------------------------------------

extern "C" {
extern int settingTotalTrack;
extern int settingTranspose;
extern int settingGenVolume;
}

bool Start(int FileHandle)
{
  InitINI();
  LoadINI(GetINIData(),GetINISize());
  
  MASTER_PCM_RATE=GlobalINI.MDXPlugin.SampleRate;
  MASTER_PCM_SAMPLES_PER_FRAME=MASTER_PCM_RATE/60;
  
  fseek(FileHandle,0,SEEK_END);
  DeflateSize=ftell(FileHandle);
  fseek(FileHandle,0,SEEK_SET);
  
  DeflateBuf=(u8*)safemalloc(DeflateSize);
  if(DeflateBuf==NULL) return(false);
  fread(DeflateBuf,1,DeflateSize,FileHandle);
  
  TiniMDXPlugin *MDXPlugin=&GlobalINI.MDXPlugin;
  settingTotalTrack=MDXPlugin->TotalTrack;
  settingTranspose=MDXPlugin->Transpose;
  settingGenVolume=MDXPlugin->GenVolume;
  
  if(StartMDX(DeflateBuf,DeflateSize,NULL,0)==false){
    if(DeflateBuf!=NULL){
      safefree(DeflateBuf); DeflateBuf=NULL;
    }
    return(false);
  }
  
  return(true);
}

void Free(void)
{
  FreeMDX();
  
  if(DeflateBuf!=NULL){
    safefree(DeflateBuf); DeflateBuf=NULL;
  }
}

u32 Update(s16 *lbuf,s16 *rbuf)
{
  return(UpdateMDX(lbuf,rbuf));
}

s32 GetPosMax(void)
{
  return(0);
}

s32 GetPosOffset(void)
{
  return(0);
}

void SetPosOffset(s32 ofs)
{
}

u32 GetChannelCount(void)
{
  return(2);
}

u32 GetSampleRate(void)
{
  return(MASTER_PCM_RATE);
}

u32 GetSamplePerFrame(void)
{
  return(MASTER_PCM_SAMPLES_PER_FRAME);
}

int GetInfoIndexCount(void)
{
  return(0);
}

bool GetInfoStrL(int idx,char *str,int len)
{
  return(false);
}

bool GetInfoStrW(int idx,UnicodeChar *str,int len)
{
  return(false);
}

bool GetInfoStrUTF8(int idx,char *str,int len)
{
  return(false);
}

// -----------------------------------------------------------

