
#include <stdio.h>

#include <NDS.h>

#include "_const.h"

#include "plugin.h"
#include "plugin_def.h"

// CallBack from plugin_dll.cpp

void cbLoadLibrary(void)
{
}

void cbFreeLibrary(void)
{
}

void cbQueryInterfaceLibrary(void)
{
}

// -----------------

bool isMSP;

typedef struct {
  u32 ID;
  u8 VersionHigh;
  u8 VersionLow;
  u8 PluginType;
  u8 Dummy0;
  u32 DataStart;
  u32 DataEnd;
  u32 gotStart;
  u32 gotEnd;
  u32 bssStart;
  u32 bssEnd;
  u32 LoadLibrary;
  u32 FreeLibrary;
  u32 QueryInterfaceLibrary;
  u32 Dummy1;
  u32 ext[4];
} TPluginHeader;

TPluginHeader PluginHeader;

char PluginInfo[1024];

bool Start(int FileHandle)
{
  isMSP=false;
  
  TPluginHeader *pPH=&PluginHeader;
  
  fread(pPH,1,sizeof(TPluginHeader),FileHandle);
  
  if(pPH->ID!=0x0050534d) return(true);
  
  isMSP=true;
  
  fread(&PluginInfo[0],1,1024,FileHandle);
  
  return(true);
}

void Free(void)
{
}

u32 Update(s16 *lbuf,s16 *rbuf)
{
  for(int idx=0;idx<256;idx++){
    *lbuf++=0;
    *rbuf++=0;
  }
  
  return(256);
}

s32 GetPosMax(void)
{
  return(0);
}

s32 GetPosOffset(void)
{
  return(0);
}

void SetPosOffset(s32 ofs)
{
}

u32 GetChannelCount(void)
{
  return(2);
}

u32 GetSampleRate(void)
{
  return(11025);
}

u32 GetSamplePerFrame(void)
{
  return(256);
}

int GetInfoIndexCount(void)
{
  return(13);
}

bool GetInfoStrL(int idx,char *str,int len)
{
  if(isMSP==false){
    switch(idx){
      case 0: snprintf(str,len,"This is not MoonShellPlugin file."); return(true); break;
    }
    return(false);
  }
  
  TPluginHeader *pPH=&PluginHeader;
  
  switch(idx){
    case 0: snprintf(str,len,"MoonShellPlugin ID=%s ver%d.%d",(char*)&pPH->ID,pPH->VersionHigh,pPH->VersionLow); return(true); break;
    case 1: {
      char *pts;
      switch(pPH->PluginType){
        case EPT_None: pts="NULL"; break;
        case EPT_Image: pts="Image"; break;
        case EPT_Sound: pts="Sound"; break;
        default: pts="undefined"; break;
      }
      char extstr[4][16]={0,};
      for(int idx=0;idx<4;idx++){
        if(pPH->ext[idx]==0){
          snprintf(extstr[idx],16,"");
          }else{
          snprintf(extstr[idx],16,"/*.%s",(char*)&(pPH->ext[idx]));
        }
      }
      snprintf(str,len,"Type:%x %s%s%s%s%s",pPH->PluginType,pts,extstr[0],extstr[1],extstr[2],extstr[3]);
      return(true);
    } break;
    case 2: {
      char *s=PluginInfo;
      snprintf(str,len,"Name=%s",s);
      return(true);
    } break;
    case 3: {
      char *s=PluginInfo;
      while(*s!=0) *s++;
      *s++;
      snprintf(str,len,"Author=%s",s);
      return(true);
    } break;
    case 4: {
      char *s=PluginInfo;
      while(*s!=0) s++;
      s++;
      while(*s!=0) s++;
      s++;
      while(*s!=0) s++;
      s++;
      char *date=s;
      while(*s!=0) s++;
      s+=3;
      char *time=s;
      while(*s!=0) s++;
      s+=2;
      char *gmt=s;
      snprintf(str,len,"%s %s %s",date,time,gmt);
      return(true);
    } break;
    case 5: snprintf(str,len,"Data 0x%08x-0x%08x",pPH->DataStart,pPH->DataEnd); return(true); break;
    case 6: snprintf(str,len,"got  0x%08x-0x%08x",pPH->gotStart,pPH->gotEnd); return(true); break;
    case 7: snprintf(str,len,"bss  0x%08x-0x%08x",pPH->bssStart,pPH->bssEnd); return(true); break;
    case 8: snprintf(str,len,"LoadLibrary 0x%08x",pPH->LoadLibrary); return(true); break;
    case 9: snprintf(str,len,"FreeLibrary 0x%08x",pPH->FreeLibrary); return(true); break;
    case 10: snprintf(str,len,"QueryInterfaceLibrary 0x%08x",pPH->QueryInterfaceLibrary); return(true); break;
    case 11: snprintf(str,len,"Dummy0 0x%08x",pPH->Dummy0); return(true); break;
    case 12: snprintf(str,len,"Dummy1 0x%08x",pPH->Dummy1); return(true); break;
  }
  
  return(false);
}

bool GetInfoStrW(int idx,UnicodeChar *str,int len)
{
  return(false);
}

bool GetInfoStrUTF8(int idx,char *str,int len)
{
  return(false);
}

// -----------------------------------------------------------

