
#ifndef _nesconst_h
#define _nesconst_h

#include "boolean.h"

#include "_const.h"

#define NTSCVsync (59.727)
#define MC6502BaseClock (1789773) // -0.5Hz
#define MC6502VsyncClock (MC6502BaseClock div NTSCVsync)

#define APU2A03_SampleRate (76400)
#define APU2A03_Renderfps (59.727)
#define APU2A03_SampleSize ((u32)(APU2A03_SampleRate/APU2A03_Renderfps) & 0xfffffff0)

#define VSMode_NTSC (0)
#define VSMode_PAL (1)
#define VSMode_Dual (2)

#define ESCF_VRCVI (BIT0)
#define ESCF_VRCVII (BIT1)
#define ESCF_FDS (BIT2)
#define ESCF_MMC5 (BIT3)
#define ESCF_Namco106 (BIT4)
#define ESCF_SunsoftFME07 (BIT5)
#define ESCF_Future6 (BIT6)
#define ESCF_Future7 (BIT7)

typedef struct {
  u8 ID[5];
  u8 VersionNumber;
  u8 TotalSongs;
  u8 StartingSong;
  u16 LoadAddress;
  u16 InitAddress;
  u16 PlayAddress;
  u8 *strName;
  u8 *strArtist;
  u8 *strCopyright;
  u16 NTSCTicksCount;
  u8 BankswitchInitValues[8];
  b8 UseBankswitch;
  u16 PALTicksCount;
  u8 VSyncMode;
  u8 ExtraSoundChipFlags;
  u8 *Data;
  u32 DataSize;
  u32 PageCount;
} TNSFInfo;

extern TNSFInfo NSFInfo;

extern b8 CPUHALT;
extern u32 CPUCycle;

#endif

