unit MainWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,math,zlib;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const PAT_HeaderSize=239;
const PAT_PCMHeaderSize=7+1+4+4+4+2+4+4+4+2+1+3+3+3+3+1+1+1+1+1+1+1+2+2+36;

const cTrue=1;
const cFalse=0;

var
  GusPath:string;

// compact
const PCM8Bit:boolean=True;
const PCMHalfRate:boolean=True;
const prefn='sfmini';
{
// full
const PCM8Bit:boolean=False;
const PCMHalfRate:boolean=False;
const prefn='sfsc88pro';
}

type
  TPAT_Header=record
    ID:array[0..22] of char; // ofs 0
    Discription:array[0..60] of char; // ofs 22
    Channels:byte; // ofs 84
    Waveforms:word; // ofs 85
    MasterVolume:word; // ofs 87
    DataSize:dword; // ofs 89
    InstrumentID:word; // ofs 129
    InstrumentName:array[0..16] of char; // ofs 131
    InstrumentSize:dword; // ofs 147
    Layers:byte; // ofs 151
    LayerDuplicate:byte; // ofs 192
    Layer:byte; // ofs 193
    LayerSize:dword; // ofs 194
    NumberOfSamples:byte; // ofs 198
  end;

var
  PAT_Header:TPAT_Header;

type
  TPAT_PCM=record
    Offset:integer;
    ID:array[0..7] of char;
    Size:integer;
    Fractions:byte;
    LoopStart:dword;
    LoopEnd:dword;
    SampleRate:word;
    RootFrequency:dword;
    VibSweep,VibRatio:double;
    VibDepth:dword;
    EnvRate,EnvOfs:array[0..6-1] of dword;
    sm16bit,smSigned,smLoop,smPing,smEnvelope:boolean;
    Data:array of byte;
  end;

var
  PAT_PCM:array of TPAT_PCM;

type
  TProgram=record
    patfn:string;

    SampleRate:dword;
    RootFreq:dword; // fix16.16
    MasterVolume:dword;
    FractionStart,FractionEnd:dword;
    Length,LoopStart,LoopEnd:dword;
    LoopFlag,s16Flag,EnvelopeFlag:dword;
    Amp:dword;
    Note,Pan:integer;
    VibSweep,VibRatio,VibDepth:dword;
    EnvRate,EnvOfs:array[0..6-1] of dword;
    Data:array of byte;
    DataCount:integer;
  end;

var
  ProgramMap:array[0..127,0..16] of TProgram;
  ProgramMapPatCount:array[0..127] of integer;

procedure InitProgramMap;
var
  prgidx:integer;
begin
  for prgidx:=0 to 128-1 do begin
    ProgramMapPatCount[prgidx]:=0;
  end;
end;

procedure LoadPATHeader(var rfs:TFileStream);
begin
  FillMemory(addr(PAT_Header),sizeof(TPAT_Header),0);

  with PAT_Header do begin
    rfs.Position:=0;
    rfs.ReadBuffer(ID,22);
    rfs.Position:=22;
    rfs.ReadBuffer(Discription,60);
    rfs.Position:=84;
    rfs.ReadBuffer(Channels,1);
    rfs.Position:=85;
    rfs.ReadBuffer(Waveforms,2);
    rfs.Position:=87;
    rfs.ReadBuffer(MasterVolume,2);
    rfs.Position:=89;
    rfs.ReadBuffer(DataSize,4);
    rfs.Position:=129;
    rfs.ReadBuffer(InstrumentID,2);
    rfs.Position:=131;
    rfs.ReadBuffer(InstrumentName,16);
    rfs.Position:=147;
    rfs.ReadBuffer(InstrumentSize,4);
    rfs.Position:=151;
    rfs.ReadBuffer(Layers,1);
    rfs.Position:=192;
    rfs.ReadBuffer(LayerDuplicate,1);
    rfs.Position:=193;
    rfs.ReadBuffer(Layer,1);
    rfs.Position:=194;
    rfs.ReadBuffer(LayerSize,4);
    rfs.Position:=198;
    rfs.ReadBuffer(NumberOfSamples,1);
  end;

  with PAT_Header do begin
    form1.Memo1.Lines.Add(format('Discription:%s',[Discription]));
    form1.Memo1.Lines.Add(format('Instrument(%x:%x):%s',[InstrumentID,InstrumentSize,InstrumentName]));
    form1.Memo1.Lines.Add(format('chs:%d wf:%d Layers:%d,%d,%d,%x',[Channels,Waveforms,Layers,LayerDuplicate,Layer,LayerSize]));
    form1.Memo1.Lines.Add(format('MasterVolume:%d NumberOfSamples:%d',[MasterVolume,NumberOfSamples]));
    form1.Memo1.Lines.Add('');
  end;


end;

procedure LoadPATPCM(var rfs:TFileStream;Index:integer);
var
  str:string;
  SamplingModes:byte;
  idx:integer;
  tmpb:byte;
  tmpdw:dword;
  tmpi:integer;
  erstr,eostr:string;
  sec:double;
  procedure halflen;
  begin
    with PAT_PCM[Index] do begin
      Size:=Size div 2;
      setlength(Data,Size);
      LoopStart:=LoopStart div 2;
      LoopEnd:=LoopEnd div 2;
    end;
  end;
  procedure u16tos16;
  var
    cnt:integer;
    pu16:PWord;
    s:integer;
  begin
    pu16:=addr(PAT_PCM[Index].Data[0]);
    for cnt:=0 to (PAT_PCM[Index].Size div 2)-1 do begin
      s:=integer(pu16^);
      s:=s-$8000;
      pu16^:=word(s);
      inc(pu16);
    end;
  end;
  procedure s16tos8;
  var
    cnt:integer;
    ps16:Psmallint;
    ps8:Pshortint;
    s:integer;
  begin
    ps16:=addr(PAT_PCM[Index].Data[0]);
    ps8:=addr(PAT_PCM[Index].Data[0]);
    for cnt:=0 to (PAT_PCM[Index].Size div 2)-1 do begin
      s:=integer(ps16^);
      s:=s shr 8;
      ps8^:=shortint(s);
      inc(ps16);
      inc(ps8);
    end;
    halflen;
  end;
  procedure u8tos8;
  var
    cnt:integer;
    pu8:Pbyte;
    ps8:Pshortint;
    s:integer;
  begin
    pu8:=addr(PAT_PCM[Index].Data[0]);
    ps8:=addr(PAT_PCM[Index].Data[0]);
    for cnt:=0 to (PAT_PCM[Index].Size div 1)-1 do begin
      s:=integer(pu8^);
      s:=s-$80;
      ps8^:=shortint(s);
      inc(pu8);
      inc(ps8);
    end;
  end;
begin
  FillMemory(addr(PAT_PCM[Index]),sizeof(TPAT_PCM),0);

  with PAT_PCM[Index] do begin
    Offset:=rfs.Position;

    rfs.Position:=Offset+0;
    rfs.ReadBuffer(ID[0],7);
    rfs.Position:=Offset+7;
    rfs.ReadBuffer(Fractions,1);
    rfs.Position:=Offset+8;
    rfs.ReadBuffer(Size,4);

    rfs.Position:=Offset+12;
    rfs.ReadBuffer(LoopStart,4);
    rfs.Position:=Offset+16;
    rfs.ReadBuffer(LoopEnd,4);
    rfs.Position:=Offset+20;
    rfs.ReadBuffer(SampleRate,2);
    rfs.Position:=Offset+30;
    rfs.ReadBuffer(RootFrequency,4);
    rfs.Position:=Offset+55;
    rfs.ReadBuffer(SamplingModes,1);

    rfs.Position:=Offset+52;
    rfs.ReadBuffer(tmpb,1);
    VibSweep:=tmpb;
    rfs.Position:=Offset+53;
    rfs.ReadBuffer(tmpb,1);
    VibRatio:=tmpb;
    rfs.Position:=Offset+54;
    rfs.ReadBuffer(VibDepth,1);

    if VibSweep<>0 then begin
      sec:=VibSweep*6.736/$100;
      VibSweep:=sec;
    end;
    if VibRatio<>0 then begin
      sec:=38/VibRatio;
      VibRatio:=sec;
    end;

    erstr:='';
    eostr:='';

    for idx:=0 to 6-1 do begin
      rfs.Position:=Offset+37+idx;
      rfs.ReadBuffer(tmpb,1);
      erstr:=erstr+inttohex(tmpb,2);
      tmpi:=3-((tmpb shr 6) and $03);
      tmpdw:=(tmpb and $3f)+1;
      tmpdw:=tmpdw shl tmpi; // .9 fixed point
      erstr:=erstr+'('+inttohex(tmpdw,4)+'),';
      EnvRate[idx]:=tmpdw;

      rfs.Position:=Offset+37+idx+6;
      rfs.ReadBuffer(tmpb,1);
      eostr:=eostr+inttohex(tmpb,2);
      tmpdw:=tmpb;
      tmpdw:=tmpdw shl 8; // .8 fixed point
      eostr:=eostr+'('+inttohex(tmpdw,4)+'),';
      EnvOfs[idx]:=tmpdw;
    end;

    form1.Memo1.Lines.Add(format('Index=%d Name=%s Start=%d Size=%dbyte.',[Index,ID,Offset,Size]));
    form1.Memo1.Lines.Add(format('LoopStart=%d LoopEnd=%d',[LoopStart,LoopEnd]));
    form1.Memo1.Lines.Add(format('SampleRate=%d RootFrequency=%.3f',[SampleRate,RootFrequency/1000]));
    form1.Memo1.Lines.Add(format('Vib Sweep=%.4fms Ratio=%.4fms Depth=%d',[VibSweep*1000,VibRatio*1000,VibDepth]));
    form1.Memo1.Lines.Add(format('Fractions=%0.2x',[Fractions]));

    str:='SamplingModes='+inttostr(SamplingModes);
    if (SamplingModes and (1 shl 0))<>0 then str:=str+'/Little16bit' else str:=str+'/8bit';
    if (SamplingModes and (1 shl 1))<>0 then str:=str+'/Unsigned' else str:=str+'/Signed';
    if (SamplingModes and (1 shl 2))<>0 then str:=str+'/Looping' else str:=str+'/OneShot';
    if (SamplingModes and (1 shl 3))<>0 then str:=str+'/Pingpong';
    if (SamplingModes and (1 shl 4))<>0 then str:=str+'/Reverse';
    if (SamplingModes and (1 shl 5))<>0 then str:=str+'/Sustein';
    if (SamplingModes and (1 shl 6))<>0 then str:=str+'/Envelope';
    if (SamplingModes and (1 shl 7))<>0 then str:=str+'/Clamped?';
    form1.Memo1.Lines.Add(str);

    form1.Memo1.Lines.Add('EnvRate='+erstr);
    form1.Memo1.Lines.Add('EnvOfs ='+eostr);

    if (SamplingModes and (1 shl 0))<>0 then sm16bit:=True else sm16bit:=False;
    if (SamplingModes and (1 shl 1))<>0 then smSigned:=False else smSigned:=True;
    if (SamplingModes and (1 shl 2))<>0 then smLoop:=True else smLoop:=False;
    if (SamplingModes and (1 shl 3))<>0 then smPing:=True else smPing:=False;
    if (SamplingModes and (1 shl 6))<>0 then smEnvelope:=True else smEnvelope:=False;

    setlength(Data,Size);
    rfs.Position:=Offset+PAT_PCMHeaderSize;
    rfs.ReadBuffer(Data[0],Size);
    rfs.Position:=Offset+PAT_PCMHeaderSize+Size;

    if (sm16bit=True) and (smSigned=False) then begin // u16
      u16tos16;
      smSigned:=True;
    end;
    if (sm16bit=True) and (smSigned=True) then begin // s16
      if PCM8Bit=True then begin
        s16tos8;
        sm16bit:=False;
      end;
    end;
    if (sm16bit=False) and (smSigned=False) then begin // u8
      u8tos8;
      smSigned:=True;
    end;
    if (sm16bit=False) and (smSigned=True) then begin // s8
    end;


    form1.Memo1.Lines.Add('');
  end;
end;

procedure LoadPatch(patfn:string);
var
  rfs:TFileStream;
  cnt:integer;
begin
  rfs:=TFileStream.Create(patfn,fmOpenRead);

  LoadPATHeader(rfs);

//  PAT_Header.NumberOfSamples:=1;

  rfs.Position:=$ef;

  setlength(PAT_PCM,PAT_Header.NumberOfSamples);

  for cnt:=0 to PAT_Header.NumberOfSamples-1 do begin
    LoadPATPCM(rfs,cnt);
  end;

  rfs.Free;
end;

procedure CopyPatch2Program(patfn:string;prgidx,patidx:integer;amp,note,pan:integer);
var
  idx:integer;
  size:integer;
begin
  ProgramMap[prgidx][patidx].patfn:=patfn;

  ProgramMap[prgidx][patidx].SampleRate:=PAT_PCM[patidx].SampleRate;
  ProgramMap[prgidx][patidx].RootFreq:=trunc(PAT_PCM[patidx].RootFrequency/1000*$10000); // fix16.16
  ProgramMap[prgidx][patidx].MasterVolume:=PAT_Header.MasterVolume;
  ProgramMap[prgidx][patidx].Length:=PAT_PCM[patidx].Size;

  ProgramMap[prgidx][patidx].FractionStart:=PAT_PCM[patidx].Fractions and $0f;
  ProgramMap[prgidx][patidx].FractionEnd:=(PAT_PCM[patidx].Fractions shr 4) and $0f;

  ProgramMap[prgidx][patidx].LoopStart:=PAT_PCM[patidx].LoopStart;
  ProgramMap[prgidx][patidx].LoopEnd:=PAT_PCM[patidx].LoopEnd;

  if PAT_PCM[patidx].sm16bit=True then ProgramMap[prgidx][patidx].s16Flag:=cTrue else ProgramMap[prgidx][patidx].s16Flag:=cFalse;
  if PAT_PCM[patidx].smLoop=True then ProgramMap[prgidx][patidx].LoopFlag:=cTrue else ProgramMap[prgidx][patidx].LoopFlag:=cFalse;
  if PAT_PCM[patidx].smEnvelope=True then ProgramMap[prgidx][patidx].EnvelopeFlag:=cTrue else ProgramMap[prgidx][patidx].EnvelopeFlag:=cFalse;

  ProgramMap[prgidx][patidx].Amp:=amp;
  ProgramMap[prgidx][patidx].Note:=note;
  ProgramMap[prgidx][patidx].Pan:=pan;

  if PAT_PCM[patidx].VibSweep=0 then begin
    ProgramMap[prgidx][patidx].VibSweep:=0;
    end else begin
    ProgramMap[prgidx][patidx].VibSweep:=trunc(1/PAT_PCM[patidx].VibSweep*$10000);
  end;
  if PAT_PCM[patidx].VibRatio=0 then begin
    ProgramMap[prgidx][patidx].VibRatio:=0;
    end else begin
    ProgramMap[prgidx][patidx].VibRatio:=trunc(1/PAT_PCM[patidx].VibRatio*$10000);
  end;
  ProgramMap[prgidx][patidx].VibDepth:=trunc((Power(1.000903,PAT_PCM[patidx].VibDepth)-1)*$10000);

  for idx:=0 to 6-1 do begin
    ProgramMap[prgidx][patidx].EnvRate[idx]:=PAT_PCM[patidx].EnvRate[idx];
    ProgramMap[prgidx][patidx].EnvOfs[idx]:=PAT_PCM[patidx].EnvOfs[idx];
  end;

  size:=PAT_PCM[patidx].Size;
  if PAT_PCM[patidx].sm16bit=True then inc(size,2) else inc(size,1);

  ProgramMap[prgidx][patidx].DataCount:=size;
  setlength(ProgramMap[prgidx][patidx].Data,ProgramMap[prgidx][patidx].DataCount);

  copymemory(addr(ProgramMap[prgidx][patidx].Data[0]),addr(PAT_PCM[patidx].Data[0]),PAT_PCM[patidx].Size);

  with ProgramMap[prgidx][patidx] do begin
    if PAT_PCM[patidx].sm16bit=True then begin
      Data[DataCount-1]:=Data[DataCount-2];
      end else begin
      Data[DataCount-2]:=Data[DataCount-4];
      Data[DataCount-1]:=Data[DataCount-3];
    end;
  end;

end;

const StripMode_None=0;
const StripMode_Loop=1;
const StripMode_Env=2;
const StripMode_Tail=3;

procedure ProcStrip(sm:integer);
var
  patidx:integer;
begin
  patidx:=0;

  case sm of
    StripMode_None: begin
    end;
    StripMode_Loop: begin
      PAT_PCM[patidx].smLoop:=False;
    end;
    StripMode_Env: begin
      PAT_PCM[patidx].smEnvelope:=False;
    end;
    StripMode_Tail: begin
      with PAT_PCM[patidx] do begin
        Size:=LoopEnd;
        setlength(Data,Size);
      end;
    end;
  end;
end;

type
  PLargeByteArray = ^TLargeByteArray;
  TLargeByteArray = array[0..65536*1000] of byte;

type
  PLargeWordArray = ^TLargeWordArray;
  TLargeWordArray = array[0..65536*1000] of word;

procedure ProcPingFlag;
var
  size:integer;
  patidx:integer;
  smptop,smpcnt,smpidx:dword;
  ps16:PLargeWordArray;
  ps8:PLargeByteArray;
begin
  patidx:=0;

  if PAT_PCM[patidx].smPing=False then exit;
  if PAT_PCM[patidx].smLoop=False then exit;

  smptop:=PAT_PCM[patidx].LoopStart;
  smpcnt:=PAT_PCM[patidx].LoopEnd-smptop;

  size:=smptop+(smpcnt*2);

  setlength(PAT_PCM[patidx].Data,size);

  ps16:=addr(PAT_PCM[patidx].Data[smptop]);
  ps8:=addr(PAT_PCM[patidx].Data[smptop]);

  if PAT_PCM[patidx].sm16bit=False then begin
    for smpidx:=0 to smpcnt-1 do begin
      ps8[smpcnt+smpidx]:=ps8[smpcnt-1-smpidx];
    end;
    end else begin
    for smpidx:=0 to smpcnt div 2-1 do begin
      ps16[(smpcnt div 2)+smpidx]:=ps16[(smpcnt div 2)-1-smpidx];
    end;
  end;

  PAT_PCM[patidx].Size:=size;
  PAT_PCM[patidx].LoopEnd:=size;

  PAT_PCM[patidx].smPing:=False;
end;

procedure ProcPCMHalfRate;
var
  patidx:integer;
  idx:integer;
  ps8:PLargeByteArray;
begin
  if PCMHalfRate=False then exit;

  patidx:=0;
  
  if PAT_PCM[patidx].sm16bit=False then begin
    ps8:=addr(PAT_PCM[patidx].Data[0]);
    for idx:=0 to (PAT_PCM[patidx].Size div 2)-1 do begin
      ps8[idx]:=ps8[idx*2+0];
    end;

    with PAT_PCM[patidx] do begin
      Size:=Size div 2;
      setlength(Data,Size);

      LoopStart:=LoopStart div 2;
      LoopEnd:=LoopEnd div 2;
      SampleRate:=SampleRate div 2;
    end;

    end else begin
    ShowMessage('not impliment PCMHalfRate for 16bitPCM');
  end;

end;

procedure LoadINI(inifn:string);
var
  prgidx,patidx:integer;
  initf:TextFile;
  str:string;
  patfn:string;
  amp,note,pan:integer;
  sm:integer;
  function LoadAttr(str:string):boolean;
  var
    pos:integer;
    function GetExtInt(name:string;defint:integer):integer;
    var
      pos:integer;
      ExtStr:string;
    begin
      Result:=defint;
      name:=name+'=';
      pos:=ansipos(name,ansilowercase(str));
      if pos=0 then exit;
      ExtStr:=copy(str,pos+length(name),255);
      pos:=ansipos(' ',ExtStr);
      if pos<>0 then ExtStr:=copy(ExtStr,0,pos-1);
      Result:=strtointdef(ExtStr,defint);
    end;
  begin
    sm:=0;

    if ansipos('strip=loop',ansilowercase(str))<>0 then sm:=StripMode_Loop;
    if ansipos('strip=env',ansilowercase(str))<>0 then sm:=StripMode_Env;
    if ansipos('strip=tail',ansilowercase(str))<>0 then sm:=StripMode_Tail;

    pos:=ansipos(' ',str);
    prgidx:=strtointdef(copy(str,1,pos-1),-1);
    if prgidx=-1 then begin
      Result:=False;
      exit;
    end;

    str:=copy(str,pos+1,length(str));

    pos:=ansipos(' ',str);
    if pos=0 then begin
      patfn:=str;
      str:='';
      end else begin
      patfn:=ansilowercase(copy(str,1,pos-1));
      str:=copy(str,pos+1,length(str));
    end;

    if ExtractFileExt(patfn)<>'.pat' then patfn:=patfn+'.pat';

    amp:=GetExtInt('amp',0);
    note:=GetExtInt('note',0);
    pan:=GetExtInt('pan',101);

    Result:=True;
  end;
begin
  AssignFile(initf,inifn);
  Reset(initf);

  while(EOF(initf)=False) do begin
    Readln(initf,str);
    if (str<>'') and (copy(str,1,1)<>'#') then begin
      if LoadAttr(str)=True then begin
        form1.Memo1.Lines.Add('-----------------------------------------');
        form1.Memo1.Lines.Add(format('prgidx=%d patfn=%s amp=%d note=%d pan=%d',[prgidx,patfn,amp,note,pan]));
        LoadPatch(GusPath+patfn);
        ProgramMapPatCount[prgidx]:=PAT_Header.NumberOfSamples;
        for patidx:=0 to ProgramMapPatCount[prgidx]-1 do begin
          ProcStrip(sm);
          ProcPingFlag;
          ProcPCMHalfRate;
          CopyPatch2Program(patfn,prgidx,patidx,amp,note,pan);
        end;
      end;
    end;

  end;

  CloseFile(initf);
end;

var
  PanpotList:array[0..128] of word;

procedure CreateTonePanpotList;
var
  cnt:integer;
begin
  for cnt:=0 to 128-1 do begin
    PanpotList[cnt]:=64;
  end;
end;

procedure CreateDrumPanpotList;
var
  cnt:integer;
begin
  for cnt:=0 to 128-1 do begin
    PanpotList[cnt]:=64;
  end;

  PanpotList[35]:=64;
  PanpotList[36]:=64;
  PanpotList[37]:=64;
  PanpotList[38]:=64;
  PanpotList[39]:=54;
  PanpotList[40]:=64;
  PanpotList[41]:=34;
  PanpotList[42]:=84;
  PanpotList[43]:=46;
  PanpotList[44]:=84;
  PanpotList[45]:=58;
  PanpotList[46]:=84;
  PanpotList[47]:=70;
  PanpotList[48]:=82;
  PanpotList[49]:=84;
  PanpotList[50]:=94;
  PanpotList[51]:=44;
  PanpotList[52]:=44;
  PanpotList[53]:=44;
  PanpotList[54]:=74;
  PanpotList[55]:=54;
  PanpotList[56]:=84;
  PanpotList[57]:=44;
  PanpotList[58]:=29;
  PanpotList[59]:=44;
  PanpotList[60]:=99;
  PanpotList[61]:=99;
  PanpotList[62]:=39;
  PanpotList[63]:=39;
  PanpotList[64]:=44;
  PanpotList[65]:=84;
  PanpotList[66]:=84;
  PanpotList[67]:=29;
  PanpotList[68]:=29;
  PanpotList[69]:=29;
  PanpotList[70]:=24;
  PanpotList[71]:=99;
  PanpotList[72]:=99;
  PanpotList[73]:=94;
  PanpotList[74]:=94;
  PanpotList[75]:=84;
  PanpotList[76]:=99;
  PanpotList[77]:=99;
  PanpotList[78]:=44;
  PanpotList[79]:=44;
  PanpotList[80]:=24;
  PanpotList[81]:=24;
end;

procedure wfszlib(var data:array of byte;datasize:integer;var wfs:TFileStream);
var
  buf:array of byte;
  idx:integer;
  EncData:PByteArray;
  EncDataSize:integer;
begin
  if datasize<=0 then exit;

  setlength(buf,datasize);
  for idx:=0 to datasize-1 do begin
    buf[idx]:=data[idx];
  end;

  ZLib.CompressBuf(pointer(buf),datasize,pointer(EncData),EncDataSize);

  if (EncData=nil) or (EncDataSize=0) then exit;

  wfs.WriteBuffer(EncData[0],EncDataSize);

  FreeMem(EncData,EncDataSize);
end;

var
  patbuf:array[0..16-1,0..1*1024*1024-1] of byte;
  patbufsize:array[0..16-1] of dword;

procedure WritePSL(pslfn:string);
var
  wfs:TFileStream;
  prgidx,patidx,patcount:integer;
  ofs,size:array[0..128] of dword;
  envidx:integer;
  procedure w32(dw:dword);
  begin
    wfs.WriteBuffer(dw,4);
  end;
  procedure wpat8(b:byte);
  begin
    patbuf[patidx][patbufsize[patidx]]:=b;
    inc(patbufsize[patidx]);
  end;
  procedure wpat32(dw:dword);
  begin
    wpat8(byte((dw shr 0) and $ff));
    wpat8(byte((dw shr 8) and $ff));
    wpat8(byte((dw shr 16) and $ff));
    wpat8(byte((dw shr 24) and $ff));
  end;
  procedure wpatbuf(data:array of byte;datasize:integer);
  var
    idx:integer;
  begin
    for idx:=0 to datasize-1 do begin
      wpat8(data[idx]);
    end;
  end;
  procedure wpatpad;
  begin
    while((patbufsize[patidx] and $3)<>0) do begin
      wpat8(0);
    end;
  end;
  procedure wpatclear;
  var
    idx:integer;
  begin
    patbufsize[patidx]:=0;
    for idx:=0 to 1*1024*1024-1 do begin
      patbuf[patidx][idx]:=0;
    end;
  end;
  procedure wpatwrite;
  begin
    wfs.WriteBuffer(patbuf[patidx][0],patbufsize[patidx]);
  end;
begin
  wfs:=TFileStream.Create(pslfn,fmCreate);

  for prgidx:=0 to 128-1 do begin
    ofs[prgidx]:=0;
    size[prgidx]:=0;
    wfs.WriteBuffer(ofs[prgidx],4);
    wfs.WriteBuffer(size[prgidx],4);
  end;

  for prgidx:=0 to 128-1 do begin
    patcount:=ProgramMapPatCount[prgidx];
    if patcount<>0 then begin
      ofs[prgidx]:=wfs.Position;

      w32(0);
      for patidx:=0 to patcount-1 do begin
        w32(0);
      end;

      for patidx:=0 to patcount-1 do begin
        wpatclear;

        with ProgramMap[prgidx][patidx] do begin
          wpat32(SampleRate);
          wpat32(RootFreq);
          if Amp=0 then begin
            wpat32(MasterVolume);
            end else begin
            wpat32((MasterVolume*Amp) div 100);
          end;
          wpat32(FractionStart);
          wpat32(FractionEnd);
          wpat32(Length);
          wpat32(LoopStart);
          wpat32(LoopEnd);
          wpat32(LoopFlag);
          wpat32(s16Flag);
          if Pan=101 then begin
            wpat32(PanpotList[prgidx]);
            end else begin
            wpat32(((Pan*64) div 100)+64);
          end;
          wpat32(Note);
          wpat32(VibSweep);
          wpat32(VibRatio);
          wpat32(VibDepth);
          wpat32(EnvelopeFlag);
          for envidx:=0 to 6-1 do begin
            wpat32(EnvRate[envidx]);
          end;
          for envidx:=0 to 6-1 do begin
            wpat32(EnvOfs[envidx]);
          end;
//          wfszlib(Data,DataCount,wfs);
          wpatbuf(Data,DataCount);
          wpatpad;
        end;

        wpatwrite;
      end;

      size[prgidx]:=wfs.Size-ofs[prgidx];

      wfs.Position:=ofs[prgidx];

      w32(patcount);
      for patidx:=0 to patcount-1 do begin
        w32(patbufsize[patidx]);
      end;

      wfs.Position:=wfs.Size;

    end;
  end;

  wfs.Position:=0;

  for prgidx:=0 to 128-1 do begin
    w32(ofs[prgidx]);
    w32(size[prgidx]);
  end;

  wfs.Free;
end;

procedure DeletePSLs;
var
  idx:integer;
begin
  for idx:=0 to 128-1 do begin
    DeleteFile(ExtractFilePath(Application.ExeName)+'sftone'+inttostr(idx)+'.psl');
    DeleteFile(ExtractFilePath(Application.ExeName)+'sfdrum'+inttostr(idx)+'.psl');
  end;
end;

procedure MakeBIN(dstfn:string);
var
  wfs:TFileStream;
  fn:string;
  idx:integer;
  toneofs,drumofs:array[0..128] of dword;
  procedure wdw(dw:dword);
  begin
    wfs.WriteBuffer(dw,4);
  end;
  procedure Padding;
  var
    ofs:integer;
    dw:dword;
  begin
    ofs:=wfs.Position;
    ofs:=ofs and $3;
    ofs:=4-ofs;
    if (ofs mod 4)<>0 then begin
      dw:=0;
      wfs.WriteBuffer(dw,ofs);
    end;
  end;
  function WriteFile(fn:string):integer;
  var
    rfs:TFileStream;
    buf:array of byte;
    size:integer;
  begin
    if FileExists(fn)=False then begin
      Result:=0;
      exit;
    end;

    Result:=wfs.Size;

    rfs:=TFileStream.Create(fn,fmOpenRead);
    size:=rfs.Size;
    setlength(buf,size);
    rfs.ReadBuffer(buf[0],size);
    rfs.Free;

    wfs.WriteBuffer(buf[0],size);

    Padding;
  end;
begin
  wfs:=TFileStream.Create(dstfn,fmCreate);

  wdw($00534650);

  wfs.Position:=4;

  for idx:=0 to 128-1 do begin
    wdw(0);
  end;
  for idx:=0 to 128-1 do begin
    wdw(0);
  end;

  for idx:=0 to 128-1 do begin
    fn:=ExtractFilePath(Application.ExeName)+'sftone'+inttostr(idx)+'.psl';
    toneofs[idx]:=WriteFile(fn);
  end;
  for idx:=0 to 128-1 do begin
    fn:=ExtractFilePath(Application.ExeName)+'sfdrum'+inttostr(idx)+'.psl';
    drumofs[idx]:=WriteFile(fn);
  end;

  wfs.Position:=4;

  for idx:=0 to 128-1 do begin
    wdw(toneofs[idx]);
  end;
  for idx:=0 to 128-1 do begin
    wdw(drumofs[idx]);
  end;

  wfs.Free;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  idx:integer;
  fn,mapfn,pslfn:string;
  procedure ProcTone(mapfn,pslfn:string);
  begin
    if FileExists(mapfn)=False then exit;
    memo1.Lines.Add(mapfn+'--------------------------------------------------------');
    InitProgramMap;
    CreateTonePanpotList;
    LoadINI(mapfn);
    WritePSL(pslfn);
  end;
  procedure ProcDrum(mapfn,pslfn:string);
  begin
    if FileExists(mapfn)=False then exit;
    memo1.Lines.Add(mapfn+'--------------------------------------------------------');
    InitProgramMap;
    CreateDrumPanpotList;
    LoadINI(mapfn);
    WritePSL(pslfn);
  end;
begin
  memo1.Clear;

  GusPath:=ExtractFilePath(Application.ExeName)+'GUS\';

  DeletePSLs;

  for idx:=0 to 128-1 do begin
    fn:='sftone'+inttostr(idx);
    mapfn:=ExtractFilePath(Application.ExeName)+prefn+'\'+fn+'.map';
    pslfn:=ExtractFilePath(Application.ExeName)+fn+'.psl';
    ProcTone(mapfn,pslfn);
  end;
  for idx:=0 to 128-1 do begin
    fn:='sfdrum'+inttostr(idx);
    mapfn:=ExtractFilePath(Application.ExeName)+prefn+'\'+fn+'.map';
    pslfn:=ExtractFilePath(Application.ExeName)+fn+'.psl';
    ProcDrum(mapfn,pslfn);
  end;

  MakeBIN(ExtractFilePath(Application.ExeName)+prefn+'.bin');

  DeletePSLs;
end;

end.
