
#include <stdio.h>

#include <NDS.h>

#include "_const.h"

#include "plugin.h"
#include "plugin_def.h"

extern "C" {
#include "jpeglib/jpeglib.h"
}

// CallBack from plugin_dll.cpp

void cbLoadLibrary(void)
{
}

void cbFreeLibrary(void)
{
}

void cbQueryInterfaceLibrary(void)
{
}

// -----------------

// ------------------------------------------------------------------------------------

#include "std.h"

static int FileHandle;

static bool cinfoInit;
static ALIGNED_VAR_IN_DTCM struct jpeg_decompress_struct cinfo;

static int imgWidth;
static int imgHeight;
static int imgBits;
static u16 **imgBufList=NULL;

static int imgCmpWidth;
static int imgCmpHeight;
static u8 *imgCmpBuf=NULL;

static struct jpeg_error_mgr jerr;

static int DecodedY;

static bool FirstDecode;

static u32 LastOffsetY;

// ------------------------------------------------------------------------------------

bool JpegStart(int FileHandle)
{
  MemSet32DMA3(0,&cinfo,sizeof(struct jpeg_decompress_struct));
  MemSet32DMA3(0,&jerr,sizeof(struct jpeg_error_mgr));
  
  fseek(FileHandle,0,SEEK_SET);
  
  // G[̃nhO
  cinfo.err = jpeg_std_error(&jerr);

  // ȍ~ jpeg CuŃG[ꍇAJďIB

  // \̂̏ݒ
  jpeg_create_decompress(&cinfo);

  // t@C̓nh̐ݒ
  jpeg_stdio_src(&cinfo, (FILE*)FileHandle);

  // t@C̏wb_̓Ǎ
  jpeg_read_header(&cinfo, TRUE);
  
  if(cinfo.progressive_mode==TRUE){
    _consolePrintf("Progressive JPEG is uncorrespondence!!\n");
    jpeg_destroy_decompress(&cinfo);
    cinfoInit=false;
    return(false);
  }

  // 𓀂̊Jn
  jpeg_start_decompress(&cinfo);

  imgWidth=cinfo.image_width;
  imgHeight=cinfo.image_height;
  imgBits=cinfo.output_components*8;
  imgCmpWidth=cinfo.output_width;
  imgCmpHeight=cinfo.output_height;
  
  imgCmpBuf=(u8*)safemalloc(imgCmpWidth*4);
  
  if(imgCmpBuf==NULL){
    _consolePrintf("can not allocate DecompressBuffer. out of memory. (imgCmpWidth=%d)\n",imgCmpWidth);
    jpeg_finish_decompress(&cinfo);
    jpeg_destroy_decompress(&cinfo);
    cinfoInit=false;
    return(false);
  }
  
  DecodedY=-1;
  
  cinfoInit=true;
  
  return(true);
}

#define Gravity(c,cg) { \
  c+=cg; \
  cg=c&7; \
  c=c>>3; \
  if((c&(~0x1f))!=0) c=(c<0) ? 0x00 : 0x1f; \
}

bool JpegNextLine(u16 *dstbuf)
{
  u16 *dest=dstbuf;
  
  if(cinfo.output_height<=cinfo.output_scanline){
    _consolePrintf("out of scanline. %d<=%d\n",cinfo.output_height,cinfo.output_scanline);
    return(false);
  }
  
  int res=jpeg_read_scanlines(&cinfo, &imgCmpBuf, 1);
  
  if(res!=1){
    _consolePrintf("error:jpeg_read_scanlines();\n");
    return(false);
  }
  
  if(dest==NULL) return(true);
  
  u8 *src=imgCmpBuf;
  
  if(imgBits==8){
    u32 gb=0;
    for(int x=imgWidth;x!=0;x--){
      u32 b;
      b=src[0];
      Gravity(b,gb);
      *dest = RGB15(b,b,b) | BIT15;
      src++;
      dest++;
    }
    }else{
    u32 gr=0,gg=0,gb=0;
    for(int x=imgWidth;x!=0;x--){
      u32 r,g,b;
      r=src[0];
      g=src[1];
      b=src[2];
      Gravity(b,gb);
      Gravity(g,gg);
      Gravity(r,gr);
      *dest = RGB15(r,g,b) | BIT15;
      src+=3;
      dest++;
    }
  }
  
  return(true);
}

#undef Gravity

void JpegFree(void)
{
  if(cinfoInit==true){
/*
    int PrgBase=cinfo.output_scanline;
    MWin_ProgressShow("seek lastimage",cinfo.output_height-PrgBase);
    while(cinfo.output_scanline<cinfo.output_height){
      if((cinfo.output_scanline&3)==0) MWin_ProgressSetPos(cinfo.output_scanline-PrgBase);
      if(JpegNextLine(NULL)==false){
        break;
      }
    }
    MWin_ProgressHide();
*/
    
    jpeg_finish_decompress(&cinfo);
    jpeg_destroy_decompress(&cinfo);
    cinfoInit=false;
  }
  
  if(imgCmpBuf!=NULL){
    safefree(imgCmpBuf); imgCmpBuf=NULL;
  }
}

// ------------------------------------------------------------------------------------

u16* GetLine(s32 y,s32 vector)
{
  if(y<0) return(NULL);
  if(imgHeight<=y) return(NULL);
  
  u16 *pSrcBM;
  
  pSrcBM=imgBufList[y];
  
  if(pSrcBM!=NULL) return(pSrcBM);
  
  pSrcBM=(u16*)safemalloc((imgWidth*2)+(32*1024));
  
  if(pSrcBM==NULL){
    s32 topy=-1;
    switch(vector){
      case -1: {
        for(s32 y=imgHeight-1;y>=0;y--){
          if(imgBufList[y]!=NULL){
            topy=y;
            break;
          }
        }
      } break;
      case 0: case 1: {
        for(u32 y=0;y<(u32)imgHeight;y++){
          if(imgBufList[y]!=NULL){
            topy=y;
            break;
          }
        }
      }
    }
    if(topy==-1){
      _consolePrintf("Jpeg DecodeCache: out of memory.\n");
      return(NULL);
    }
    if(extmem_Exists(topy)==false){
      if(extmem_Alloc(topy,imgWidth*2)==true){
        extmem_Write(topy,imgBufList[topy],imgWidth*2);
      }
    }
    pSrcBM=imgBufList[topy];
    imgBufList[topy]=NULL;
    
    }else{
    safefree(pSrcBM); pSrcBM=NULL;
    pSrcBM=(u16*)safemalloc(imgWidth*2);
  }
  
  imgBufList[y]=pSrcBM;
  
  if(extmem_Exists(y)==true){
    extmem_Read(y,imgBufList[y],imgWidth*2);
    return(imgBufList[y]);
  }
  
  if(y<=DecodedY){
    JpegFree();
    if(JpegStart(FileHandle)==false) return(NULL);
  }
  
  if(DecodedY<(y-1)){
    int PrgBase=DecodedY;
    MWin_ProgressShow("SkipImage",y-PrgBase);
    
    while(DecodedY<(y-1)){
      if((DecodedY&15)==0) MWin_ProgressSetPos(DecodedY-PrgBase);
      if(JpegNextLine(NULL)==false){
        safefree(imgBufList[y]); imgBufList[y]=NULL;
        return(NULL);
      }
      DecodedY++;
    }
    
    MWin_ProgressHide();
  }
  
  if(DecodedY!=(y-1)){
    _consolePrintf("seek error. %d!=(%d-1)\n",DecodedY,y);
    ShowLogHalt();
  }
  
  if(JpegNextLine(imgBufList[y])==true){
    DecodedY++;
    return(imgBufList[y]);
    }else{
    safefree(imgBufList[y]); imgBufList[y]=NULL;
    return(NULL);
  }
}

bool Start(int _FileHandle)
{
  cinfoInit=false;
  
  if(_FileHandle==0){
    _consolePrintf("FileHandle is NULL\n");
    return(false);
  }
  
  FileHandle=_FileHandle;
  
  if(JpegStart(FileHandle)==false) return(false);
  
  LastOffsetY=0;
  
  extmem_SetCount(imgHeight);
  
  imgBufList=(u16**)safemalloc(imgHeight*4);
  MemSet32DMA3(0,imgBufList,imgHeight*4);
  
  if(imgBufList==NULL){
    _consolePrintf("can not allocate ImageBuffer pointer list. out of memory.\n");
    JpegFree();
    return(false);
  }
  
  FirstDecode=true;
  
  return(true);
}

void Free(void)
{
  FileHandle=0;
  
  if(imgBufList!=NULL){
    for(int y=0;y<imgHeight;y++){
      if(imgBufList[y]!=NULL){
        safefree(imgBufList[y]); imgBufList[y]=NULL;
      }
    }
    safefree(imgBufList); imgBufList=NULL;
  }
  
  JpegFree();
}

typedef struct {
  s32 x,y,w,h;
} TRect;

void RefreshScreen(u32 OffsetX,u32 OffsetY,u16 *pBuf,u32 BufWidth,u32 DrawWidth,u32 DrawHeight,bool HalfMode)
{
//  _consolePrintf("%d,%d 0x%x,%d %d,%d %d\n",OffsetX,OffsetY,(u32)pBuf,BufWidth,DrawWidth,DrawHeight,HalfMode);
  
  s32 Vector;
  
  if(LastOffsetY==OffsetY){
    Vector=0;
    }else{
    if(LastOffsetY<OffsetY){
      Vector=1;
      }else{
      Vector=-1;
    }
  }
  LastOffsetY=OffsetY;
  
  u32 BaseX=OffsetX,BaseY=OffsetY;
  
  TRect ClientRect;
  
  ClientRect.x=0;
  ClientRect.y=0;
  ClientRect.h=DrawHeight;
  ClientRect.w=DrawWidth;
  
  s32 DrawH,DrawW;
  
  DrawW=imgWidth;
  DrawH=imgHeight;
  
  if(DrawW>ClientRect.w) DrawW=ClientRect.w;
  if(DrawH>ClientRect.h) DrawH=ClientRect.h;
  
  if(FirstDecode==true) MWin_ProgressShow("Decoding...",DrawH);
  
  if(HalfMode==false){
    for(s32 y=0;y<DrawH;y++){
      if(FirstDecode==true){
        if((y&15)==0) MWin_ProgressSetPos(y);
      }
      u16 *pSrcBM=GetLine(BaseY+y,Vector);
      u16 *pDstBM=&pBuf[ClientRect.x+((ClientRect.y+y)*BufWidth)];
      
      if(pSrcBM!=NULL){
        pSrcBM+=BaseX;
        MemCopy16DMA3(pSrcBM,pDstBM,DrawW*2);
      }
    }
    
    }else{ // half
    
    for(s32 y=0;y<DrawH/2;y++){
      if(FirstDecode==true){
        if((y&15)==0) MWin_ProgressSetPos(y);
      }
      u16 *pSrcBM0=GetLine(BaseY+(y*2)+0,Vector);
      u16 *pSrcBM1=GetLine(BaseY+(y*2)+1,Vector);
      u16 *pDstBM=&pBuf[ClientRect.x+((ClientRect.y+y)*BufWidth)];
      
      if((pSrcBM0!=NULL)&&(pSrcBM1!=NULL)){
        pSrcBM0+=BaseX;
        pSrcBM1+=BaseX;
        for(int x=0;x<DrawW/2;x++){
          u32 r=0,g=0,b=0;
          u32 rgb;
          
          rgb=pSrcBM0[x*2+0];
          r+=(rgb >> 0) & 0x1f; g+=(rgb >> 5) & 0x1f; b+=(rgb >> 10) & 0x1f;
          rgb=pSrcBM0[x*2+1];
          r+=(rgb >> 0) & 0x1f; g+=(rgb >> 5) & 0x1f; b+=(rgb >> 10) & 0x1f;
          rgb=pSrcBM1[x*2+0];
          r+=(rgb >> 0) & 0x1f; g+=(rgb >> 5) & 0x1f; b+=(rgb >> 10) & 0x1f;
          rgb=pSrcBM1[x*2+1];
          r+=(rgb >> 0) & 0x1f; g+=(rgb >> 5) & 0x1f; b+=(rgb >> 10) & 0x1f;
          
          pDstBM[x]=BIT15 | RGB15(r/4,g/4,b/4);
        }
        
      }
    }
  }
  
  if(FirstDecode==true) MWin_ProgressHide();
  
  FirstDecode=false;
}

s32 GetWidth(void)
{
  return(cinfo.image_width);
}

s32 GetHeight(void)
{
  return(cinfo.image_height);
}

int GetInfoIndexCount(void)
{
  return(2);
}

bool GetInfoStrL(int idx,char *str,int len)
{
  switch(idx){
    case 0: snprintf(str,len,"ImageSize=%dx%dx%dbitColor",imgWidth,imgHeight,imgBits); return(true); break;
    case 1: snprintf(str,len,"ComponentSize=%dx%dpixels",imgCmpWidth,imgCmpHeight); return(true); break;
  }
  return(false);
}

bool GetInfoStrW(int idx,UnicodeChar *str,int len)
{
  return(false);
}

bool GetInfoStrUTF8(int idx,char *str,int len)
{
  return(false);
}

